Unit T_LNG;

{ (c) Jury Fradkin 1996, Spb }

Interface

Function OpenLng(Const FileName : String) : Word; { opening  of LNG-file, return value - number of messages in LNG-file }
Procedure CloseLng;                               { closing of LNG-file }
Function GetLng(N : Word) : String;               { get message at number }
Function GetLngKey(N : Word) : String;            { get the first part of message (before beginning of format) }


Implementation

Uses Strings;

Type
   TTab = Array[0..16383] Of Word;

Var
   Table : ^TTab;
   Body  : PChar;
   Size  : LongInt;
   Count : Word;

Function OpenLng(Const FileName : String) : Word;
Var
   F           : File;
   OldFileMode : Byte;
   I, J        : Integer;
   P           : PChar;

Begin
   CloseLng;
   {$I-}
   Begin
      Assign(F,FileName);
      If IOResult <> 0 Then Exit;
      OldFileMode := FileMode;
      FileMode := 0;
      Reset(F,1);
      FileMode := OldFileMode;
      If IOResult <> 0 Then Exit;
      Size := FileSize(F);
      GetMem(Body,Size);
      BlockRead(F,Body^,Size);
      If IOResult <> 0 Then Exit;

      P := Body;
      For I:=1 To Size-2 Do Begin
          If P^ = Chr(0) Then Inc(Count);
          P := P + 1;
      End;

      GetMem(Table,2*(Count+1));
      P := Body;
      Table^[0] := 0;
      J := 0;
      For I:=1 To Size-2 Do Begin
          If P^ = Chr(0) Then Begin
             Inc(J);
             Table^[J] := I;
          End;
          P := P + 1;
      End;
   End;
   Close(F);
   IF IOResult <> 0 Then Count:=0;
   {$I+}
   If Count = 0 Then CloseLng;
   OpenLng := Count;
End;

Procedure CloseLng;
Begin
   If Body <> NIL Then Begin
      FreeMem(Body,Size);
      Body := NIL;
   End;
   If Table <> NIL Then Begin
      FreeMem(Table,Count);
      Table := NIL;
   End;
   Count := 0;
   Size := 0;
End;

Function GetLng(N : Word) : String;
Begin
   If (N <= Count) Then
      GetLng := StrPas(Body+Table^[N-1])
   Else
      Getlng := '';
End;

Function GetLngKey(N : Word) : String;
Var
   S : String;
   L : Byte;
Begin
   S:=GetLng(N);
   L:=Pos('%',S);
   If L > 0 Then
      S := Copy(S,0,L-1);
   GetLngKey := S;
End;

Begin
   Body  := NIL;
   Table := NIL;
   Count := 0;
   Size  := 0;
End.
